From 101f70f366863598f85b25e5f355d5890bef3a56 Mon Sep 17 00:00:00 2001
From: Gabriele Musco <gabmus@disroot.org>
Date: Sun, 26 Nov 2023 22:32:45 +0100
Subject: [PATCH 23/54] feat: redesign performance and power states sections

---
 .../root_stack/oc_page/performance_frame.rs   | 113 ++++++++----------
 .../power_states/power_states_frame.rs        |  24 ++--
 lact-gui/ui/oc_page/gpu_stats_section.blp     |   2 +-
 lact-gui/ui/oc_page/power_states_frame.blp    |  31 ++---
 4 files changed, 70 insertions(+), 100 deletions(-)

diff --git a/lact-gui/src/app/root_stack/oc_page/performance_frame.rs b/lact-gui/src/app/root_stack/oc_page/performance_frame.rs
index 33f1c049..a5a29510 100644
--- a/lact-gui/src/app/root_stack/oc_page/performance_frame.rs
+++ b/lact-gui/src/app/root_stack/oc_page/performance_frame.rs
@@ -5,16 +5,14 @@ use gtk::*;
 use lact_client::schema::amdgpu_sysfs::gpu_handle::{
     power_profile_mode::PowerProfileModesTable, PerformanceLevel,
 };
+use libadwaita::prelude::{ComboRowExt, ActionRowExt};
 use std::{cell::RefCell, rc::Rc, str::FromStr};
 
 #[derive(Clone)]
 pub struct PerformanceFrame {
     pub container: PageSection,
-    level_drop_down: DropDown,
-    mode_drop_down: DropDown,
-    description_label: Label,
-    manual_info_button: MenuButton,
-    mode_box: Box,
+    level_row: libadwaita::ComboRow,
+    mode_row: libadwaita::ComboRow,
     modes_table: Rc<RefCell<Option<PowerProfileModesTable>>>,
 }
 
@@ -22,68 +20,54 @@ impl PerformanceFrame {
     pub fn new() -> Self {
         let container = PageSection::new("Performance");
 
+        let listbox = ListBox::builder()
+            .css_classes(["boxed-list"])
+            .selection_mode(SelectionMode::None)
+            .build();
+
         let levels_model: StringList = ["Automatic", "Highest Clocks", "Lowest Clocks", "Manual"]
             .into_iter()
             .collect();
 
-        let level_box = Box::new(Orientation::Horizontal, 10);
-
-        let level_drop_down = DropDown::builder()
+        let level_row = libadwaita::ComboRow::builder()
             .model(&levels_model)
+            .title("Performance level")
+            .subtitle("")
+            .subtitle_lines(0)
             .sensitive(false)
             .build();
-        let description_label = Label::builder().halign(Align::End).hexpand(true).build();
-        let perfromance_title_label = Label::builder().label("Performance level:").build();
 
-        level_box.append(&perfromance_title_label);
-        level_box.append(&description_label);
-        level_box.append(&level_drop_down);
+        listbox.append(&level_row);
 
-        container.append(&level_box);
+        let filler_model: StringList = [""].into_iter().collect();
 
-        let mode_box = Box::new(Orientation::Horizontal, 10);
-
-        let mode_drop_down = DropDown::builder()
+        let mode_row = libadwaita::ComboRow::builder()
+            .model(&filler_model)
+            .title("Power level mode")
+            .subtitle("Set \"Performance level\" to \"Manual\" to use power states and modes")
+            .subtitle_lines(0)
             .sensitive(false)
-            .halign(Align::End)
             .build();
 
-        let unavailable_label = Label::new(Some(
-            "Performance level has to be set to \"manual\" to use power states and modes",
-        ));
-        let mode_info_popover = Popover::builder().child(&unavailable_label).build();
-        let manual_info_button = MenuButton::builder()
-            .icon_name("dialog-information-symbolic")
-            .hexpand(true)
-            .halign(Align::End)
-            .popover(&mode_info_popover)
-            .build();
+        listbox.append(&mode_row);
 
-        let mode_title_label = Label::new(Some("Power level mode:"));
-        mode_box.append(&mode_title_label);
-        mode_box.append(&manual_info_button);
-        mode_box.append(&mode_drop_down);
-
-        container.append(&mode_box);
+        container.append(&listbox);
 
         let frame = Self {
             container,
-            level_drop_down,
-            mode_drop_down,
-            description_label,
-            manual_info_button,
-            mode_box,
+            level_row,
+            mode_row,
             modes_table: Rc::new(RefCell::new(None)),
         };
 
         frame
-            .level_drop_down
+            .level_row
             .connect_selected_notify(clone!(@strong frame => move |_| {
                 frame.update_from_selection();
             }));
 
         frame
-            .mode_drop_down
+            .mode_row
             .connect_selected_notify(clone!(@strong frame => move |_| {
                 frame.update_from_selection();
             }));
@@ -92,18 +76,18 @@ impl PerformanceFrame {
     }
 
     pub fn set_active_level(&self, level: PerformanceLevel) {
-        self.level_drop_down.set_sensitive(true);
+        self.level_row.set_sensitive(true);
         match level {
-            PerformanceLevel::Auto => self.level_drop_down.set_selected(0),
-            PerformanceLevel::High => self.level_drop_down.set_selected(1),
-            PerformanceLevel::Low => self.level_drop_down.set_selected(2),
-            PerformanceLevel::Manual => self.level_drop_down.set_selected(3),
+            PerformanceLevel::Auto => self.level_row.set_selected(0),
+            PerformanceLevel::High => self.level_row.set_selected(1),
+            PerformanceLevel::Low => self.level_row.set_selected(2),
+            PerformanceLevel::Manual => self.level_row.set_selected(3),
         };
         self.update_from_selection();
     }
 
     pub fn set_power_profile_modes(&self, table: Option<PowerProfileModesTable>) {
-        self.mode_box.set_visible(table.is_some());
+        self.mode_row.set_visible(table.is_some());
 
         match &table {
             Some(table) => {
@@ -114,41 +98,42 @@ impl PerformanceFrame {
                     .position(|key| *key == table.active)
                     .expect("No active mode") as u32;
 
-                self.mode_drop_down.set_model(Some(&model));
-                self.mode_drop_down.set_selected(active_pos);
+                self.mode_row.set_model(Some(&model));
+                self.mode_row.set_selected(active_pos);
+
+                // set mode_row sensitivity because it gets reset to sensitive
+                // after setting the model
+                self.update_from_selection();
 
-                self.mode_drop_down.show();
+                self.mode_row.show();
             }
             None => {
-                self.mode_drop_down.hide();
+                self.mode_row.hide();
             }
         }
         self.modes_table.replace(table);
     }
 
     pub fn connect_settings_changed<F: Fn() + 'static + Clone>(&self, f: F) {
-        self.level_drop_down
+        self.level_row
             .connect_selected_notify(clone!(@strong f => move |_| f()));
-        self.mode_drop_down.connect_selected_notify(move |_| f());
+        self.mode_row.connect_selected_notify(move |_| f());
     }
 
     pub fn get_selected_performance_level(&self) -> PerformanceLevel {
-        let selected_item = self
-            .level_drop_down
-            .selected_item()
-            .expect("No selected item");
+        let selected_item = self.level_row.selected_item().expect("No selected item");
         let string_object = selected_item.downcast_ref::<StringObject>().unwrap();
         PerformanceLevel::from_str(string_object.string().as_str())
             .expect("Unrecognized selected performance level")
     }
 
     pub fn get_selected_power_profile_mode(&self) -> Option<u16> {
-        if self.mode_drop_down.is_sensitive() {
+        if self.mode_row.is_sensitive() {
             self.modes_table.borrow().as_ref().map(|table| {
                 let selected_index = table
                     .modes
                     .keys()
-                    .nth(self.mode_drop_down.selected() as usize)
+                    .nth(self.mode_row.selected() as usize)
                     .expect("Selected mode out of range");
                 *selected_index
             })
@@ -160,7 +145,7 @@ impl PerformanceFrame {
     fn update_from_selection(&self) {
         let mut enable_mode_control = false;
 
-        let text = match self.level_drop_down.selected() {
+        self.level_row.set_subtitle(match self.level_row.selected() {
             0 => "Automatically adjust GPU and VRAM clocks. (Default)",
             1 => "Always use the highest clockspeeds for GPU and VRAM.",
             2 => "Always use the lowest clockspeeds for GPU and VRAM.",
@@ -169,12 +154,8 @@ impl PerformanceFrame {
                 "Manual performance control."
             }
             _ => unreachable!(),
-        };
-        self.description_label.set_text(text);
-        self.mode_drop_down.set_sensitive(enable_mode_control);
-
-        self.manual_info_button.set_visible(!enable_mode_control);
-        self.mode_drop_down.set_hexpand(enable_mode_control);
+        });
+        self.mode_row.set_sensitive(enable_mode_control);
     }
 
     pub fn show(&self) {
diff --git a/lact-gui/src/app/root_stack/oc_page/power_states/power_states_frame.rs b/lact-gui/src/app/root_stack/oc_page/power_states/power_states_frame.rs
index a49f1dfe..c37bcd95 100644
--- a/lact-gui/src/app/root_stack/oc_page/power_states/power_states_frame.rs
+++ b/lact-gui/src/app/root_stack/oc_page/power_states/power_states_frame.rs
@@ -1,14 +1,12 @@
 use std::collections::HashMap;
 
-use gtk::{
-    glib::{self, subclass::types::ObjectSubclassIsExt, Object},
-    prelude::WidgetExt,
-};
+use crate::app::page_section::PageSection;
+use gtk::glib::{self, subclass::types::ObjectSubclassIsExt, Object};
 use lact_client::schema::{amdgpu_sysfs::gpu_handle::PowerLevelKind, DeviceStats, PowerStates};
 
 glib::wrapper! {
     pub struct PowerStatesFrame(ObjectSubclass<imp::PowerStatesFrame>)
-        @extends gtk::Widget,
+        @extends PageSection, gtk::Box, gtk::Widget,
         @implements gtk::Accessible, gtk::Buildable;
 }
 
@@ -20,11 +18,6 @@ impl PowerStatesFrame {
     pub fn set_power_states(&self, states: PowerStates) {
         let imp = self.imp();
 
-        imp.expander.set_sensitive(!states.is_empty());
-        if states.is_empty() {
-            imp.expander.set_expanded(false);
-        }
-
         imp.core_states_list.set_power_states(states.core, "MHz");
         imp.vram_states_list.set_power_states(states.vram, "MHz");
     }
@@ -65,7 +58,10 @@ impl Default for PowerStatesFrame {
 }
 
 mod imp {
-    use crate::app::root_stack::oc_page::power_states::power_states_list::PowerStatesList;
+    use crate::app::{
+        page_section::PageSection,
+        root_stack::oc_page::power_states::power_states_list::PowerStatesList,
+    };
     use gtk::{
         glib::{self, subclass::InitializingObject, Properties, StaticTypeExt},
         prelude::ObjectExt,
@@ -73,7 +69,7 @@ mod imp {
             prelude::*,
             widget::{CompositeTemplateClass, WidgetImpl},
         },
-        CompositeTemplate, Expander,
+        CompositeTemplate,
     };
     use std::sync::atomic::AtomicBool;
 
@@ -81,8 +77,6 @@ mod imp {
     #[properties(wrapper_type = super::PowerStatesFrame)]
     #[template(file = "ui/oc_page/power_states_frame.blp")]
     pub struct PowerStatesFrame {
-        #[template_child]
-        pub expander: TemplateChild<Expander>,
         #[template_child]
         pub core_states_list: TemplateChild<PowerStatesList>,
         #[template_child]
@@ -96,7 +90,7 @@ mod imp {
     impl ObjectSubclass for PowerStatesFrame {
         const NAME: &'static str = "PowerStatesFrame";
         type Type = super::PowerStatesFrame;
-        type ParentType = gtk::Box;
+        type ParentType = PageSection;
 
         fn class_init(class: &mut Self::Class) {
             PowerStatesList::ensure_type();
diff --git a/lact-gui/ui/oc_page/gpu_stats_section.blp b/lact-gui/ui/oc_page/gpu_stats_section.blp
index e41c6ecf..6253af34 100644
--- a/lact-gui/ui/oc_page/gpu_stats_section.blp
+++ b/lact-gui/ui/oc_page/gpu_stats_section.blp
@@ -2,7 +2,7 @@ using Gtk 4.0;
 using Adw 1;
 
 template $GpuStatsSection: $PageSection {
-    name: "GPU Statistics";
+    name: "GPU statistics";
     spacing: 12;
 
     Box {
diff --git a/lact-gui/ui/oc_page/power_states_frame.blp b/lact-gui/ui/oc_page/power_states_frame.blp
index 0271aa91..a6652956 100644
--- a/lact-gui/ui/oc_page/power_states_frame.blp
+++ b/lact-gui/ui/oc_page/power_states_frame.blp
@@ -1,26 +1,21 @@
 using Gtk 4.0;
 
-template $PowerStatesFrame: Box {
-    Expander expander {
-        label: "Power states";
+template $PowerStatesFrame: $PageSection {
+    name: "Power states";
+    spacing: 12;
 
-        Box {
-            margin-start: 10;
-            margin-end: 10;
-            margin-top: 10;
-            margin-bottom: 10;
-            spacing: 10;
-            orientation: horizontal;
+    Box {
+        orientation: horizontal;
+        spacing: 12;
 
-            $PowerStatesList core_states_list {
-                title: "GPU power states";
-                sensitive: bind template.configurable;
-            }
+        $PowerStatesList core_states_list {
+            title: "GPU power states";
+            sensitive: bind template.configurable;
+        }
 
-            $PowerStatesList vram_states_list {
-                title: "VRAM power states";
-                sensitive: bind template.configurable;
-            }
+        $PowerStatesList vram_states_list {
+            title: "VRAM power states";
+            sensitive: bind template.configurable;
         }
     }
 }

